<?php 
 
/**
 * AI request data  functionality
 */
add_action('wp_ajax_image_rewrite_ai_call', 'wad_image_rewrite_ai_call');
function wad_image_rewrite_ai_call(){
	global $current_user, $wpdb;
	if( check_ajax_referer( 'ajax_call_nonce', 'security') ){
		
		$settings = get_option('wad_options');
 
		$open_ai_key =  $settings['chat_gpt_key'];  
 
		$query = sanitize_text_field( $_POST['query'] );

		$tmp = get_option('tmp1');

		if( !$tmp ){
			$url = 'https://api.openai.com/v1/images/generations';

			$result = wp_remote_post( $url, [
				'timeout' => 1000000,
				'headers' => [
					'Content-Type' => 'application/json',
					'Authorization' => 'Bearer '.$open_ai_key,
				],
				'body' => json_encode( [
					"prompt" => $query,
					"n" => 1,
					"size" => "1024x1024"
				] )
				

			]);
			
	 

			$processing_result = false;
			$decoded_response = json_decode( $result['body'] );
 
			if( $decoded_response )
				if( isset( $decoded_response->error->message ) ){
					$out_text = $decoded_response->error->message;
					
				}else{
					$out_text = $decoded_response->data[0]->url;
					$processing_result = true;
				}
	
			else{
				
				$processing_result = false;
			}
				

			//update_option('tmp', $out_text );
		}else{
			$out_text = $tmp;
		}
		
 
		if( $processing_result ){		
			echo json_encode( array( 'result' => 'success', 'text' => trim( $out_text ) ) );	
		}else{
			echo json_encode( array( 'result' => 'error', 'text' => $out_text ) );
		}
 
		
	}
	die();
}



add_action('wp_ajax_save_image_to_library', 'wad_save_image_to_library');
function wad_save_image_to_library(){
	global $current_user, $wpdb;
	if( check_ajax_referer( 'ajax_call_nonce', 'security') ){
		
	 
		$url =  $_POST['url']  ;

		$attach_id = classCoreHelperAI::add_image( $url );
		$processing_result = false;
 

		if( $attach_id ){
			$processing_result = true;
		}
 
		if( $processing_result ){		
			echo json_encode( array( 'result' => 'success', 'text' => admin_url( '/upload.php?item='.$attach_id ) ) );	
		}else{
			echo json_encode( array( 'result' => 'error', 'text' => 'Image generation failed' ) );
		}
 
		
	}
	die();
}
?>